type Company @model {
    id: ID!
    name: String!
    # relations
    users: [User] @relation(name: "CompanyUsers")
}

enum Role {
    ROOT
    ADMIN
    MANAGER
}

type User @model(type: "User") {
    id: ID!
    name: String!
    email: String!      @isUnique
    password: String!   @hidden
    role: Role! @default(value: MANAGER)
    # relations
    company: Company! @relation(name: "CompanyUsers") @ownedBy
    posts: [Post!] @relation(name: "UserPosts")
}

type Post @model {
    id: ID!
    title: String!
    text: String!
    # relations
    user: User!    @relation(name: "UserPosts") @ownedBy
    comments: [Comment] @relation(name: "PostComments")
}

type Comment @model {
    id: ID!
    text: String!
    # relations
    user: User!
    #company: Company! # https://github.com/staudenmeir/belongs-to-through
    post: Post! @relation(name: "PostComments") @ownedBy

    parent: Comment @relation(name: "CommentReplies")
    replies: [Comment] @relation(name: "CommentReplies")
}